#! /usr/local/bin/perl

###################################################
#BooEasyVotingSystem v1.02 / this program is free.#
#(C) BooBooClub 2003-2007                         #
###################################################


#set data

$view = './view.html';
$vote = './vote.dat';
$tmp = './tmp.dat';
$tlimit = '1';


#read lib;
require './jcode.pl';


#read
if ($ENV{'REQUEST_METHOD'} eq "POST"){
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}
else{
	#$buffer = $ENV{'QUERY_STRING'};
	exit 0;
}


@pairs = split(/&/,$buffer);
foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ tr/,//;
	$value =~ s/\cM\n//g;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ s/\r\n|[\r\n]//g;
	&jcode'convert(*value,'sjis');
	$FORM{$name} = $value;
}


#filelock;
&lock;


#branch

if($FORM{'vote_submit'}){
	&vote;
}
&html;



sub vote{

	#DoubleVoteCheck
	open(TMP,"$tmp");
	@tmpdats = <TMP>;
	close (TMP);
	$chk = 0;
	$nowtime = time();
	foreach $tmpdats(@tmpdats){
		@etmp = split(/,/,$tmpdats);
		if($etmp[0]+60*60*$tlimit > $nowtime){
			if($ENV{'REMOTE_ADDR'} eq $etmp[1]){
				$chk++;
			}
			push(@newtmp,$tmpdats);
		}
	}
	if($chk == 0){
		$newtmpline = $nowtime.','.$ENV{'REMOTE_ADDR'}.','."\n";
		push(@newtmp,$newtmpline);
	}
	open (TMP,">$tmp");
	print TMP @newtmp;
	close (TMP);

	if($chk != 0){
		&html;
	}

	#Vote
	open (DAT,"$vote");
	@votedats = <DAT>;
	close (DAT);

	if($FORM{'vote'} ne 'other'){
		foreach $votedats(@votedats){
			@evote = split(/,/,$votedats);
			if($evote[0] eq $FORM{'vote'}){
				$evote[1]++;
				$votedats = join(',',@evote);
			}
			push(@newdat,$votedats);
		}
	}
	else{
		@newdat = @votedats;
		$newline = $FORM{'other'}.',1,'."\n";
		push(@newdat,$newline);
	}

	open (DAT,">$vote");
	print DAT @newdat;
	close (DAT);
}



sub html{

	open (DAT,"$vote");
	@votedats = <DAT>;
	close (DAT);

	$list_view = '';
	$list_vote = '';
	foreach $votedats(@votedats){
		@evote = split(/,/,$votedats);
		$list_view .= '<tr><td>'."$evote[0]".'</td><td align="right">'."$evote[1]".'</td></tr>'."\n";
		$list_vote .= '<input type="radio" name="vote" value="'."$evote[0]".'">'."$evote[0]".'<br>'."\n";
	}


	open (HTML,"$view");
	$html = join('',<HTML>);
	close (HTML);

	$html =~ s/<!--VIEW-->/$list_view/;
	$html =~ s/<!--VOTE-->/$list_vote/;

	print "Content-type: text/html\n\n";
	print $html;
	unlink("$lockfile"); 
	exit 0;
}



sub lock{
	$lockfile = './lock/lockfile';
	$retry = 1;
	until (symlink("$dat", "$lockfile")){
		if (++$retry >= 30){
			unlink("$lockfile"); 
			exit 0;
		}
		sleep(1);
	}
}

